include Math
def connectlines(lines)
    0.upto(lines.length-2) do |i|
      r=0
      if lines.length>1
        line1=lines[i]
        (i+1).upto(lines.length-1) do |j|
          line2=lines[j]
          v1=line1.end.position-line1.start.position
          v2=line2.end.position-line2.start.position
          if v1.parallel? v2
            if line1.start.position==line2.start.position
              p1=line1.end.position
              p2=line2.end.position
              lines.erase_entities [lines[i],lines[j]]
              lines.add_line(p1,p2)
              r=1
              break
            end
            if line1.start.position==line2.end.position
              p1=line1.end.position
              p2=line2.start.position
              lines.erase_entities [lines[i],lines[j]]
              lines.add_line(p1,p2)
              r=1
              break
            end
            if line1.end.position==line2.start.position
              p1=line1.start.position
              p2=line2.end.position
              lines.erase_entities [lines[i],lines[j]]
              lines.add_line(p1,p2)
              r=1
              break
            end
            if line1.end.position==line2.end.position
              p1=line1.start.position
              p2=line2.start.position
              lines.erase_entities [lines[i],lines[j]]
              lines.add_line(p1,p2)
              r=1
              break
            end
          end
        end #j
        # retry if r==1
      end#if
    end#i
  lines
end#def

def drawprofile(shape,w,h,gp)
    #model=Sketchup.active_model
    ents=gp.entities#model.active_entities
    po=Geom::Point3d.new 0,0,0
    v_vertical=Geom::Vector3d.new 0,0,100
    gp=ents.add_group
    ent_gp=gp.entities
  case shape
    when "circle"
    circle=ent_gp.add_circle po,v_vertical,w
    ent_gp.add_face circle
    when "square"
    ent_gp.add_face [[w/2,h/2,0.mm],[w/2,-h/2,0.mm],[-w/2,-h/2,0.mm],[-w/2,h/2,0.mm]]
  end
end

def drawsolidline(v_start,v_end,gp,shape,w,h,notpush)
  #model=Sketchup.active_model
  ents=gp.entities#model.active_entities

  v_line=v_end-v_start
  v_vertical=Geom::Vector3d.new 0,0,1
  v_x=Geom::Vector3d.new 1,0,0
  if v_line.parallel? v_vertical
    v_rotatenormal=v_x
    else
    v_rotatenormal=v_vertical.cross v_line
  end
  
  po=Geom::Point3d.new 0,0,0
  t_rotate_yz=Geom::Transformation.rotation po,v_x,PI/2
  
  #rotate on xy plan
  v_t1=Geom::Vector3d.new v_line.x,v_line.y,0
  v_t2=Geom::Vector3d.new 0,-1,0
  anglexy=v_t2.angle_between v_t1
  anglexy=2*PI-anglexy if v_line.x<0
  anglexy=0 if v_line.parallel? v_vertical
  t_rotate_xy=Geom::Transformation.rotation po,v_vertical,anglexy
  
  #face to line
  angle=v_t1.angle_between v_line
  angle=-angle if v_line.z>0
  t_rotate_linexy=Geom::Transformation.rotation po,v_x,angle
  t_move=Geom::Transformation.new v_start
  
  #draw somthing
  face_Section=drawprofile(shape,w,h,gp)
  
  #do transformation and pushpull
  #~ ents.transform_entities t_rotate,face_Section
  #~ ents.transform_entities t_move,face_Section
  ents.transform_entities t_rotate_yz,face_Section
  ents.transform_entities t_rotate_linexy,face_Section
  ents.transform_entities t_rotate_xy,face_Section
  ents.transform_entities t_move,face_Section
  if notpush!="true"
    face_Section.pushpull -v_line.length,false
  end
end

#  Menu interfaces
def edge2tube(r,p)
model=Sketchup.active_model
ents=model.active_entities
model.start_operation "line to tube"

#select lines
ss=model.selection
lines=[]
ss.each do |i|
  lines.push(i) if i.typename=="Edge"
end

return if lines.length==0

#prosses each edge
lines.each do |i|
  drawsolidline(i.start.position,i.end.position,ss,"circle",r,0.mm)
end

model.commit_operation
end

def edge2cube(w,h,p)
model=Sketchup.active_model
ents=model.active_entities
model.start_operation "line to cube"

#select lines
ss=model.selection

ss.each do |i|
  ss.remove i if i.typename!="Edge"
end
return if ss.length==0
gp=ents.add_group ss
gents=gp.entities
gents=connectlines(gents)

#prosses each edge
gedges=[];gents.each{|i| gedges.push(i)}
gedges.each do |i|
  drawsolidline(i.start.position,i.end.position,gp,"square",w,h,p) if i.typename=="Edge"
end

dellines=[]
gents.each{|i| dellines.push(i) if i.typename=="Edge"}
gents.erase_entities dellines

model.commit_operation
end